Import brl.timer
Import brl.random
Import brl.PNGLoader

Import "Includes/SaveAndLoad.bmx"
Import "Includes/LittleCLasses.bmx"
Import "Includes/GUI.bmx"
Import "Includes/Maths.bmx"
Import "Includes/Images.bmx"


SuperStrict

Graphics 1024, 768

SeedRnd MilliSecs()

AutoMidHandle(1)



Global RedButton:Tbutton = TButton.Create(40, GraphicsHeight() - 18, 248, 48, 48, tiButton, tiNumbers[0], tiButtonSelected, 1)
Global GreenButton:TButton = TButton.Create(GraphicsWidth() / 2, GraphicsHeight() - 18, 47, 247, 47, tiButton, tiNumbers[1], tiButtonSelected, 2)
Global BlueButton:TButton = TButton.Create(GraphicsWidth() - 40, GraphicsHeight() - 18, 49, 49, 249, tiButton, tiNumbers[2], tiButtonSelected, 3)
RedButton.SelectThis()

Global Abstand:Int = 5
Global Size:Int = 40

Local FTimer:TTimer = CreateTimer(60)
Local MH:Int = 0
Local MHR:Int = 0
Local MX:Int
Local MY:Int
Local ALTX:Int
Local ALTy:Int
Local LineSet:Int = 0
Local Mode:Int = 1

While Not KeyHit(KEY_ESCAPE) Or AppTerminate()
	WaitTimer(FTimer)
	Cls
	
	
	MH = MouseHit(1)
	MHR = MouseHit(2)
	MX = MouseX()
	MY = MouseY()
	
	If KeyHit(KEY_UP) Then Mode = 1
	If KeyHit(KEY_DOWN) Then Mode = 2
	
	SetColor 255, 255, 255
	DrawLine(90, 40, GraphicsWidth() - 90, 40)
	DrawLine(GraphicsWidth() - 90, 40, GraphicsWidth() - 90, GraphicsHeight() - 190)
	DrawLine(GraphicsWidth() - 90, GraphicsHeight() - 190, 90, GraphicsHeight() - 190)
	DrawLine(90, GraphicsHeight() - 190, 90, 40)
	
	GetKey()
	
	For Local Button:TButton = EachIn TButton.AllButtons
		Button.Draw()
		If Button.iIsSelected = 1 Then
			SetColor Button.iRed, Button.iGreen, Button.iBlue
			DrawImage tiBrick, MX, MY
			SetColor 255, 255, 255
		End If
	Next

	If KeyHit(KEY_NUMADD) Then Abstand:+1
	If KeyHit(KEY_NUMSUBTRACT) Then Abstand:-1
	If Abstand < 0 Then Abstand = 0
	
	If MH Then
		Local tmpButton:TButton
		For Local Button:TButton = EachIn TButton.AllButtons
			If Button.iIsSelected = 1 Then tmpButton = Button
		Next
		If ((MX >= 100) And (MX <= GraphicsWidth() - 100)) And ((MY >= 50) And (MY <= GraphicsHeight() - 200)) Then
			Local newBrick:TBrick = TBrick.Create(MX, MY, tmpButton.iRed, tmpButton.iGreen, tmpButton.iBlue, tibrick, "Enemy")
		EndIf
	End If
	
	If MouseDown(1) Then
		Local tmpButton:TButton
		For Local Button:TButton = EachIn TButton.AllButtons
			If Button.iIsSelected = 1 Then tmpButton = Button
		Next
			If Mode = 1 Then
				If ((MX >= 100) And (MX <= GraphicsWidth() - 100)) And ((MY >= 50) And (MY <= GraphicsHeight() - 200)) Then
					Local Brick:TBrick = TBrick.Create(MX, MY, tmpButton.iRed, tmpButton.igreen, tmpbutton.iBlue, tibrick, "Enemy")
					Brick.ProofDistance()
				EndIf
			
			ElseIf Mode = 2 Then
				If LineSet = 0 Then
					ALTX = MX
					ALTy = MY
					LineSet = 1
				End If
		
				Line(MX, MY, ALTX, ALTy, tmpButton, 0)
			EndIf
		
	Else
	 
	 	If Mode = 2 Then
	 		If LineSet = 1 Then
				Local tmpButton:TButton
				For Local Button:TButton = EachIn TButton.AllButtons
					If Button.iIsSelected = 1 Then tmpButton = Button
				Next
	 			Line(MX, MY, ALTX, ALTy, tmpButton, 1)
			End If
			LineSet = 0
		EndIf
	EndIf
	
	If MouseDown(2) Then
		For Local Brick:TBrick = EachIn TBrick.AllBricks
			If (Pythagoras(MX, MY, Brick.iX, Brick.iy) <= 10) Then Brick.Destroy()
		Next
	End If
	
	If KeyHit(KEY_F3) Then
		RandomLevel()
	EndIf
	
	For Local Brick:TBrick = EachIn TBrick.AllBricks
		Brick.Draw()
	Next
	
	If KeyHit(KEY_F1) Then SaveLevel()
	If KeyHit(KEY_F2) Then LoadLevel(0)
	
	DrawText "Abstand: " + Abstand, 70, 70
	If Mode = 1 Then
		DrawText "Modus: 1 = Freihand", 70, 100
	ElseIf Mode = 2 Then
		DrawText "Modus: 2 = Linien", 70, 100
	EndIf
	
	Flip 0
Wend

Function Line(x:Int, y:Int, Firstx:Int, Firsty:Int, choosenButton:TButton, Set:Int)
		Local Gesamt:Int = Size + Abstand
		Local VecLength:Float
		Local VecX:Float, VecY:Float
		Local Amount:Int
		Local PiecesX:Float, PiecesY:Float
		
		SetColor choosenButton.ired, choosenButton.igreen, choosenButton.iblue
		DrawLine(Firstx, Firsty, x, y)
		VecX = (x - Firstx)
		VecY = (y - Firsty)
		VecLength = Sqr(VecX * VecX + VecY * VecY)
		Amount = VecLength / Gesamt
		PiecesX = VecX / Amount
		PiecesY = VecY / Amount
		
		For Local index:Int = 0 To Amount
			Local BrickX:Int, BrickY:Int
			BrickX = (PiecesX * index) + Firstx
			BrickY = (PiecesY * index) + Firsty
			If ((BrickX >= 100) And (BrickX <= GraphicsWidth() - 100)) And ((bricky >= 50) And (bricky <= GraphicsHeight() - 200)) Then
				DrawImage(tiBrick, BrickX, BrickY)
				If Set = 1 Then
					Local newBrick:TBrick = TBrick.Create(Brickx, Bricky, choosenButton.ired, choosenButton.igreen, choosenButton.iblue, tibrick, "Enemy")
					newBrick.ProofDistance()
				End If
			EndIf
		Next
		
		
		SetColor 255, 255, 255
End Function

Function RandomLevel()
	Local Amount:Int = Rand(30, 40)
	
	For Local i:Int = 1 To Amount
		Local Colour:Int = Rand(1, 3)
		Local tmpRed:Int, tmpGreen:Int, tmpBlue:Int
		Local tmpX:Int = Rand(100, GraphicsWidth() - 100)
		Local tmpY:Int = Rand(50, GraphicsHeight() - 200)
		
		Select Colour
			Case 1
				tmpRed = RedButton.ired
				tmpGreen = RedButton.igreen
				tmpBlue = RedButton.iBlue
			Case 2
				tmpRed = GreenButton.iRed
				tmpGreen = GreenButton.iGreen
				tmpBlue = GreenButton.iBlue
			Case 3
				tmpRed = BlueButton.iRed
				tmpGreen = BlueButton.iGreen
				tmpBlue = BlueButton.iblue
		End Select
		
		Local tmpBrick:TBrick = TBrick.Create(tmpx, tmpy, tmpred, tmpgreen, tmpblue, tiBrick, "Enemy")
		tmpBrick.SetAtPlace()
	Next
End Function

Function GetKey()
	If KeyHit(KEY_1) Then RedButton.SelectThis
	If KeyHit(KEY_2) Then GreenButton.SelectThis
	If KeyHit(KEY_3) Then BlueButton.SelectThis
End Function

