Import "Maths.bmx"
SuperStrict

Type TCircle
	Global AllCircle:TList = New TList
	Field iX:Int, iY:Int
	Field ired:Int, igreen:Int, iblue:Int
	
	Method New()
		AllCircle.Addlast(Self)
	End Method
	
	Function Create:TCircle(pX:Int, pY:Int)
		Local C:TCircle = New TCircle
		C.iX = pX
		C.iY = pY
		C.ProofDistance()
		Return C
	End Function
	
	Method ProofDistance:Int()
		Local Hits:Int = 0
		For Local tmpCircle:TCircle = EachIn TCircle.AllCircle
			If tmpCircle <> Self Then
				If (Pythagoras(iX, iY, tmpCircle.iX, tmpCircle.iY) <= 37) Then
					Self.Destroy
					Hits:+1
				EndIf
			EndIf
		Next
		If Hits = 0 Then Return True
	End Method
	
	Method Destroy()
		AllCircle.Remove(Self)
	End Method
End Type


Type TBrick
	Global AllBricks:TList = New TList
	Field iX:Int, iY:Int
	Field ired:Int, igreen:Int, iblue:Int
	Field iChecksum:Int
	Field sFraction:String
	Field tiImage:TImage
	Field iSpeed:Int = 3
	
	Method New()
		AllBricks.Addlast(Self)
	End Method
	
	Function Create:TBrick(pX:Int, pY:Int, pRed:Int, pGreen:Int, pBlue:Int, pImage:TImage, pFraction:String)
		Local B:TBrick = New TBrick
		
		B.ired = pRed
		B.igreen = pGreen
		B.iblue = pBlue
		B.iChecksum = pRed + pGreen + pBlue
		
		B.sFraction = pFraction
		B.iX = pX
		B.iY = py
		B.tiImage = pImage
		Return B
	End Function
	
		Method ProofDistance()
			For Local tmpBrick:TBrick = EachIn TBrick.AllBricks
			If tmpBrick <> Self Then
				If (Pythagoras(iX, iY, tmpBrick.iX, tmpBrick.iY) <= 40) Then
					Self.Destroy
				EndIf
			EndIf
		Next
	End Method
	
	Method Draw()
		SetColor ired, igreen, iblue
		DrawImage(tiImage, iX, iY)
		SetColor 255, 255, 255
	End Method
	
	Method Collide:Int()
		If sFraction = "Player" Then
			For Local tmpBrick:TBrick = EachIn AllBricks
				If (Pythagoras(iX, iY, tmpBrick.iX, tmpBrick.iY) <= 36) Then
					If ImagesCollide(tiImage, iX, iY, 0, tmpBrick.tiImage, tmpBrick.iX, tmpBrick.iY, 0) Then
						If ((sFraction = "Player") And (tmpBrick.sFraction = "Enemy")) Then
							If (tmpBrick.iChecksum = iChecksum) Then
								tmpBrick.Destroy()
								Return True
							Else
								Self.Destroy()
								Return False
							EndIf
						End If
					End If
				EndIf
			Next
		EndIf
	End Method
	
	Method SetAtPlace() 'Method to make sure that the distance between the Bricks isn't too short
		Local Tries:Int = 0 'Variable for the Amount of Tries
				
		While BrickInRange()
			Tries:+1
			iX = Rand(100, GraphicsWidth() - 100)
			iY = Rand(50, GraphicsHeight() - 200)
			
			If (Tries >= 5) Then
				AllBricks.Remove(Self)
				Exit
			EndIf
			
		Wend
	End Method
	
	Method BrickInRange:Int()
		For Local Brick:TBrick = EachIn AllBricks
			If brick <> Self Then
				If (Pythagoras(iX, iY, Brick.iX, Brick.iY) <= 40) Then
					Return True
				EndIf
			End If
		Next
		Return False
	End Method
	
	Method Move()
		If sFraction = "Player" Then
			iY = iY - iSpeed
		End If
	End Method
	
	Method Fall()
		If sFraction = "Enemy" Then
			iY = iY + iSpeed
		End If
	End Method
	
	Method Destroy()
		AllBricks.Remove(Self)
	End Method
End Type