﻿Import brl.timer
Import brl.random
Import brl.PNGLoader
Import "Includes/SaveAndLoad.bmx"
Import "Includes/LittleCLasses.bmx"
Import "Includes/GUI.bmx"
Import "Includes/Maths.bmx"
Import "Includes/Images.bmx"

SuperStrict

Graphics 1024, 768

SeedRnd MilliSecs()

AutoMidHandle(1)

Global Level:Int = 1

Global RedButton:Tbutton = TButton.Create(40, GraphicsHeight() - 18, 248, 48, 48, tiButton, tiNumbers[0], tiButtonSelected, 1)
Global GreenButton:TButton = TButton.Create(GraphicsWidth() / 2, GraphicsHeight() - 18, 47, 247, 47, tiButton, tiNumbers[1], tiButtonSelected, 2)
Global BlueButton:TButton = TButton.Create(GraphicsWidth() - 40, GraphicsHeight() - 18, 49, 49, 249, tiButton, tiNumbers[2], tiButtonSelected, 3)
RedButton.SelectThis()

Global FTimer:TTimer = CreateTimer(60)
Local MH:Int = 0
Local MX:Int
Local MY:Int

Global PaintEnergy:Int = 130

Const Game_Menue:Int = 1
Const Game_Start:Int = 2
Const Game_ChangeLevel:Int = 3
Const Game_Lost:Int = 4

Global Game_State:Int = Game_Menue

Global ChangeLevel:Int
Global ChangeWait:Int = 1000
Global LevelChange:Int = 0

Global LevelTime:Int = 60000
Global LevelStart:Int

LoadLevel(Level)

While Not KeyHit(KEY_ESCAPE) Or AppTerminate()
	WaitTimer(FTimer)
	Cls
	
	Select Game_State
		Case 1
		
			For Local Button:TButton = EachIn TButton.AllButtons
				Button.Draw()
			Next
			For Local Brick:TBrick = EachIn TBrick.AllBricks
				Brick.Draw()
			Next
			
			DrawText("ENTER Druecken zum starten", GraphicsWidth() / 2, GraphicsHeight() / 2)
			
			If KeyHit(KEY_RETURN) Then
				LevelStart = MilliSecs()
				Game_State = Game_Start
			EndIf
		
		Case 2
			Local EndLevel:Int = 0
			Local Time:Int = ((LevelStart + LevelTime) - MilliSecs()) / 1000
			
			
			MH = MouseHit(1)
			MX = MouseX()
			MY = MouseY()
	
			GetKey()
	
			For Local Button:TButton = EachIn TButton.AllButtons
				Button.Draw()
			Next
	
			If MouseDown(1) Then
				If PaintEnergy >= 10 Then
					Local Circle:TCircle = TCircle.Create(MX, MY)
					If Circle.ProofDistance() Then PaintEnergy:-10
				EndIf
		
				For Local Circle:TCircle = EachIn TCircle.AllCircle
					For Local Button:TButton = EachIn TButton.Allbuttons
						If Button.iIsSelected = 1 Then
							SetColor Button.ired, Button.igreen, Button.iblue
							DrawOval(Circle.iX, Circle.iY, 10, 10)
							SetColor 255, 255, 255
						EndIf
					Next
				Next
			Else
				SetBricks()
				For Local Circle:TCircle = EachIn TCircle.AllCircle
					Circle.Destroy()
				Next
			EndIf
	
			For Local Brick:TBrick = EachIn TBrick.AllBricks
				If ((LevelStart + LevelTime) < MilliSecs()) Then
					Brick.Fall()
				End If
				Brick.Move()
				Brick.Draw()
				If Brick.Collide() Then PaintEnergy:+10
				If PaintEnergy > 130 Then PaintEnergy = 130
				If Brick.iy < 0 Then Brick.Destroy()
				If Brick.sfraction = "Enemy" Then
					EndLevel:+1
					If Brick.iY > GraphicsWidth() Then Game_State = Game_Lost
				EndIf
			Next
			
			If (EndLevel = 0) And (LevelChange <> 1) Then
				ChangeLevel = MilliSecs()
				LevelChange = 1
			EndIf
			
			
			If LevelChange = 1 Then
				If ((ChangeLevel + ChangeWait) > MilliSecs()) Then
					DrawText("Level geschafft", GraphicsWidth() / 2, GraphicsHeight() / 2)
				ElseIf ((ChangeLevel + ChangeWait) < MilliSecs()) Then
					For Local Brick:TBrick = EachIn TBrick.AllBricks
						Brick.Destroy()
					Next
					Level = Level + 1
					LevelChange = 0
					Game_State = Game_ChangeLevel
				EndIf
			End If
			
			DrawText "Restzeit: " + Time, 100, 70
			DrawText "Farbenergie:", 20, 150
			For Local index:Int = 0 To (PaintEnergy / 10) - 1
				Local y:Int = 10 * index
				DrawImage(tiEnergy, 50, 300 - y)
			Next
			
		Case 3
			If Level < 13 Then
				LoadLevel(Level)
				PaintEnergy = 130
				Game_State = Game_Menue
			ElseIf Level > 13 Then
				DrawText "Spiel gewonnen. GLÜCKWUNSCH", GraphicsWidth() / 2, GraphicsHeight() / 2
				DrawText "Enter druecken um von vorne zu beginnen", GraphicsWidth() / 2, GraphicsHeight() / 2 + 100
				If KeyHit(KEY_RETURN) Then
					Level = 1
					LoadLevel(Level)
					PaintEnergy = 130
					Game_State = Game_Menue
				EndIf
			EndIf
				
		
		Case 4
			For Local Brick:TBrick = EachIn TBrick.AllBricks
						Brick.Destroy()
			Next
			DrawText "Spiel verloren", GraphicsWidth() / 2, GraphicsHeight() / 2
			DrawText "Enter druecken um neu zu starten", GraphicsWidth() / 2, GraphicsHeight() / 2 + 100
			If KeyHit(KEY_RETURN) Then
				Level = 1
				Game_State = Game_ChangeLevel
			EndIf
			
		End Select
		
		
		
	Flip 0
Wend

Function SetBricks()
	For Local Circle:TCircle = EachIn TCircle.AllCircle
		For Local Button:TButton = EachIn TButton.AllButtons
			If Button.iIsSelected = 1 Then
				Local Brick:TBrick = TBrick.Create(Circle.iX, GraphicsHeight() + Circle.iy, button.iRed, button.iGreen, button.iBlue, tiBrick, "Player")
			EndIf
		Next
	Next
End Function

Function GetKey()
	If KeyHit(KEY_1) Then RedButton.SelectThis
	If KeyHit(KEY_2) Then GreenButton.SelectThis
	If KeyHit(KEY_3) Then BlueButton.SelectThis
End Function

