
Type TComponent Extends TDynamicObject
	
	Field AnimMax
	Field Anim
	Field Speed
	Field Img:TImage
	Field ImgOver:TImage
	Field Timer
	Field ID
	Field Active
	Field Switch
	Field Edited
	Field Group
	
	Field Adult:TDynamicObject
	Field Drag:TDrag
	
	
	Function Init:TComponent( lX, lY, lID, limg:TImage, lSwitch = 0, lAnimMax = 1, lImgOver:TImage = Null, lSpeed = 0 )
		
		t:TComponent = New TComponent
		
		t.X = lX
		t.Y = lY
		t.W = ImageWidth( limg )
		t.H = ImageHeight( limg )
		t.Img = limg
		t.AnimMax = lAnimMax
		t.Speed = lSpeed
		t.ImgOver = lImgOver
		t.ID = lID
		t.Anim = 0
		t.Switch = lSwitch
		
		Return t
		
	End Function
	
	
	Method Update( lX, lY, lDown )
		
		If AnimMax > 0 And Timer+Speed < MilliSecs() Then
			Anim = (Anim + 1) Mod AnimMax
			Timer = MilliSecs()
		EndIf
		
		If Drag Then Drag.Update( lX, lY, lDown, Adult.X, Adult.Y )
		If Switch And over(lX-Adult.X, lY-Adult.Y) And MH Then
			Active = (Active+1)Mod 2
			Edited = 1
		EndIf
		
	End Method
	
	
	Method Draw( lX, lY )
		
		If ( over(lX-Adult.X, lY-Adult.Y) Or Active ) And ImgOver Then
			DrawImage ImgOver, Adult.X+X, Adult.Y+Y
		Else
			DrawImage Img, Adult.X+X, Adult.Y+Y, Anim
		EndIf
		
	End Method
	
End Type