
Type TDrag
	
	Const SOFT = 0
	Const HARD = 1
	
	Global IsDrag = 0
	
	Field Drag
	Field OldX:Float
	Field OldY:Float
	Field OffX:Float
	Field OffY:Float
	Field BoundMinX
	Field BoundMinY
	Field BoundMaxX
	Field BoundMaxY
	Field Mode
	
	Field Parent:TDynamicObject
	
	
	Function Init:TDrag( lMinX, lMinY, lMaxX, lMaxY, lMode, lOther:TDynamicObject )
		
		t:TDrag = New TDrag
		
		t.BoundMinX = lMinX
		t.BoundMinY = lMinY
		t.BoundMaxX = lMaxX
		t.BoundMaxY = lMaxY
		t.Mode = lMode
		t.Parent = New TDynamicObject
		t.Parent = lOther
		
		Return t
		
	End Function
	
	
	Method Update( lX, lY, lDown, lRelX=0, lRelY=0 )
		
		If Drag = 1 And Not Parent.over( lX-lRelX, lY-lRelY ) And lDown Then Drag = 0
		If Drag = 1 And Parent.over( lX-lRelX, lY-lRelY ) And lDown Then
			OffX = lX - Parent.X
			OffY = lY - Parent.Y
			Drag = 2
		EndIf
		
		If Drag = 2 Then
			TDrag.IsDrag = 1
			Parent.X = lX - OffX
			Parent.Y = lY - OffY
		EndIf
		If Not lDown Then Drag = 1
		
		If Parent.X < BoundMinX Then Parent.X = BoundMinX
		If Parent.Y < BoundMinY Then Parent.Y = BoundMinY
		If Parent.X > BoundMaxX-Parent.W Then Parent.X = BoundMaxX-Parent.W
		If Parent.Y > BoundMaxY-Parent.H Then Parent.Y = BoundMaxY-Parent.H
		
		If Mode = TDrag.SOFT Then SoftDrag()
		
	End Method
	
	
	Method SoftDrag()
		
		Local TempOldX:Float = (Parent.X-OldX)/1.1
		Local TempOldY:Float = (Parent.Y-OldY)/1.1
		OldX = Parent.X
		OldY = Parent.Y
		If Drag = 1 Then
			Parent.X :+ TempOldX
			Parent.Y :+ TempOldY
		EndIf
		
	End Method
	
End Type