
Type TEditPanel Extends TDynamicObject
	
	Field OldX:Float
	Field OldY:Float
	Field OffX
	Field OffY
	Field NoDrag
	Field Group:Int[][]
	
	Field Components:TList
	Field Drag:TDrag
	
	Field imgBackground:TImage
	
	
	Function Init:TEditPanel( lX, lY, lBack:TImage )
		
		t:TEditPanel = New TEditPanel
		
		t.X = lX
		t.Y = lY
		t.imgBackground = lBack
		t.W = ImageWidth( lBack )
		t.H = ImageHeight( lBack )
		t.Components = CreateList()
		
		Return t
		
	End Function
	
	
	Method Update()
		
		Local EditID
		Local EditGID
		NoDrag = 0
		
		For C:TComponent = EachIn Components
			C.Update( MX, MY, MD )
			
			If C.Edited Then
				EditID = C.ID
				EditGID = C.Group
				C.Edited = 0
			EndIf
		Next
		
		If EditID Then
			For C:TComponent = EachIn Components
				If C.Group = EditGID And C.ID <> EditID Then
					C.Active = 0
				EndIf
			Next
		EndIf
		
		If Not TDrag.IsDrag And Drag Then Drag.Update( MX, MY, MD )
		TDrag.ISDrag = 0
		
	End Method
	
	
	Method Draw()
		
		DrawImage imgBackground, X, Y
		
		For C:TComponent = EachIn Components
			C.Draw( MX, MY )
		Next
		
	End Method
	
	
	Method AddComponents( lComp:TComponent[] )
		
		For I = 0 To lComp.length-1
			lComp[I].Adult = Self
			Components.AddLast( lComp[I] )
		Next
		
	End Method
	
	
	Method AddGroup( lComp:TComponent[] )
		
		Local gLength = Group.length
		
		Group = Group[ ..gLength+1 ]
		Group[ gLength ] = New Int[ lComp.length ]
		
		For I = 0 To lComp.length-1
			Group[ gLength ][I] = lComp[I].ID
			lComp[I].Group = gLength+1
		Next
		
	End Method
	
	
	Method GetComponent:TComponent( lID )
		
		For C:TComponent = EachIn Components
			If C.ID = lID Then Return C
		Next
		
	End Method
	
EndType



