
Type TEditor Extends TMode
	
	Field Area:TArea
	
	Function Init:TEditor( lGraphX, lGraphY, lArrowLeft:TImage, lArrowRight:TImage, lArrowAnimMax, lArrowSpeed, lLevel:TLevel, lPhysics:TPhysics, lPlayer:TPlayer, lPanel:TEditPanel )
		
		t:TEditor = New TEditor
		t.InitValues( lGraphX, lGraphY, lArrowLeft, lArrowRight, lArrowAnimMax, lArrowSpeed, lLevel:TLevel, lPhysics:TPhysics, lPlayer:TPlayer, lPanel:TEditPanel )
		Return t
		
	End Function
	
	
	Method Update()
		
		Player.Draw( ScrollX, ScrollY )
		Level.Draw( ScrollX, ScrollY )
		UpdatePhysics()
		If KeyHit( KEY_SPACE ) Then Physics.SetForces( 0, 1.5 )
		
		For C:TComponent = EachIn Panel.Components
			
			If C.Active Then
			
				If Not Panel.over( MX, MY )
					If MD And C.ID = 5 Then
						Level.SetForce( Panel.GetComponent( 4 ).X+4 - Panel.GetComponent( 4 ).Drag.BoundMinX )
						Level.Transform( ScrollX, 0, MX, MY, RADIUS, 50 )
					EndIf
					
					If Area And C.ID = 7 Or C.ID = 8 Then
						Area.Update( MX, MY, MD )
						If KeyHit( KEY_RETURN ) Then
							If C.ID = 7 Then Level.SetMode( Area.X, Area.W, ScrollX, TLevel.FLEXIBLE )
							If C.ID = 8 Then Level.SetMode( Area.X, Area.W, ScrollX, TLevel.HARD )
						EndIf
					EndIf
					
					If C.ID = 10 Then
						DrawImage TCheckpoint.Img, MX-TCheckpoint.R, MY-TCheckpoint.R
						If MH Then Level.AddCheckpoint( TCheckpoint.Init( MX+ScrollX, MY+ScrollY ) )
					EndIf
					
					If C.ID = 9 Then
						DrawImage TTarget.Img, MX-TTarget.R, MY-TTarget.R
						If MH Then Level.SetTarget( MX+ScrollX, MY+ScrollY )
					EndIf
					
					If C.ID = 11 Then
						DrawImage Player.imgBall[0], MX, MY
						If MH Then Player.SetPosition( MX+ScrollX, MY+ScrollY )
					EndIf
				EndIf
				
				If C.ID = 1 Then Physics.SetForces( 0, 1.5 )
				If C.ID = 2 Then
					Physics.SetForces( 0, 0 )
					Player.ResetPosition()
				EndIf
				
				If C.ID = 12 Then Level.Speed = (Panel.GetComponent( 14 ).X - Panel.GetComponent( 14 ).Drag.BoundMinX)/3
				
				If Area And C.ID = 7 Or C.ID = 8 Then Area.Draw()
			EndIf
			
			If MH And C.ID = 15 And C.over( MX-Panel.X, MY-Panel.Y ) Then
				Print "Gespeichert"
				SaveLevel()
			EndIf
			
		Next
		
		Panel.Update()
		Panel.Draw()
		
		Scroll( 0, Level.Plots-GraphX, 0, 0, MX, MY, 50, GraphX-50, 0, 0, SOFT, 3 )
		
		TScroll.ScrollX = ScrollX
		TScroll.ScrollY = ScrollY
		
	End Method
	
	
	Method SetArea( lArea:TArea )
		
		Area = lArea
		
	End Method
	
	
	Method SaveLevel()
		
		Local File:TStream
		Local n = 0
		
		File = WriteFile ( "Maps\level.z99" )
		If Not File Then Return
		
		WriteInt File, Level.Plots
		
		For I = 0 To Level.Plots-1
			WriteFloat File, Level.XPos[I]
			WriteFloat File, Level.YPos[I]
			WriteFloat File, Level.Mode[I]
		Next
		
		For C:TCheckpoint = EachIn Level.Checkpoints
			n:+1
		Next
		WriteInt File, n
		
		For C:TCheckpoint = EachIn Level.Checkpoints
			WriteFloat File, C.X
			WriteFloat File, C.Y
		Next
		
		WriteFloat File, Level.Target.X
		WriteFloat File, Level.Target.Y
		WriteFloat File, Level.Speed
		
		WriteFloat File, Player.X
		WriteFloat File, Player.Y
		
		CloseFile (File)
		
	End Method
	
EndType









