
Type TGame Extends TMode
	
	Field sLevel:String
	Field Run
	
	Function Init:TGame( lGraphX, lGraphY, lArrowLeft:TImage, lArrowRight:TImage, lArrowAnimMax, lArrowSpeed, lLevel:TLevel, lPhysics:TPhysics, lPlayer:TPlayer, lPanel:TEditPanel )
		
		t:TGame = New TGame
		t.InitValues( lGraphX, lGraphY, lArrowLeft, lArrowRight, lArrowAnimMax, lArrowSpeed, lLevel:TLevel, lPhysics:TPhysics, lPlayer:TPlayer, lPanel:TEditPanel )
		Return t
		
	End Function
	
	
	Method Update()
		
		Player.Draw( ScrollX, ScrollY )
		Level.Draw( ScrollX, ScrollY )
		UpdatePhysics()
		
		
		For C:TC = EachIn Panel.Components
			
			If C.Active Then
				If Not Panel.over( MX, MY )
					
					If MD And Not Run And C.ID = 5 Then
						Level.SetForce( Panel.GetComponent( 4 ).X+4 - Panel.GetComponent( 4 ).Drag.BoundMinX )
						Level.Transform( ScrollX, 0, MX, MY, RADIUS, 50 )
					EndIf
					
				EndIf
				
				
				If C.ID = 1 Then
					Physics.SetForces( 0, 1.5 )
					Run = 1
				EndIf
				If C.ID = 2 Then
					Physics.SetForces( 0, 0 )
					Player.ResetPosition()
					Run = 0
					For CP:TCheckpoint = EachIn Level.Checkpoints
						CP.State= 0
					Next
				EndIf
			EndIf
			
			If C.ID = 6 And MH And C.over( MX-Panel.X, MY-Panel.Y ) Then LoadLevel( sLevel )
		Next
		
		
		Panel.Update()
		Panel.Draw()
		
		If Not Run Then Scroll( 0, Level.Plots-GraphX, 0, 0, MX, MY, 50, GraphX-50, 0, 0, SOFT, 3 )
		If Run Then Scroll( 0, Level.Plots-GraphX, 0, 0, Player.X-ScrollX, Player.Y-ScrollY, GraphX/2-100, GraphX/2+100, 0, 0, SOFT, 20 )
		
		If Level.UpdateCheckpoints( Player.X, Player.Y, Player.R ) Then
			Return 1
		EndIf
		
		TScroll.ScrollX = ScrollX
		TScroll.ScrollY = ScrollY
		
		If ESC Then Return 0
		
		Return -1
		
	EndMethod
	
	
	Method LoadLevel( Path:String )
		
		Local File:TStream
		Local n
		
		sLevel = Path
		
		File = ReadFile ( Path )
		If Not File Then Return
		
		Level.Plots = ReadInt( File )
		
		Level.XPos = Level.XPos[ ..Level.Plots ]
		Level.YPos = Level.YPos[ ..Level.Plots ]
		Level.Mode = Level.Mode[ ..Level.Plots ]
		
		For I = 0 To Level.Plots-1
			Level.XPos[I] = ReadFloat( File )
			Level.YPos[I] = ReadFloat( File )
			Level.Mode[I] = ReadFloat( File )
		Next
		
		For C:TCheckpoint = EachIn Level.Checkpoints
			Level.Checkpoints.Remove( C )
		Next
		n = ReadInt( File )
		
		For I = 0 To n-1
			C = New TCheckpoint
			C.X = ReadFloat( File )
			C.Y = ReadFloat( File )
			C.State = 0
			Level.Checkpoints.AddLast( C )
		Next
		
		Level.Target.X = ReadFloat( File )
		Level.Target.Y = ReadFloat( File )
		Level.Target.State = 0
		Level.Speed = ReadFloat( File )
		
		Local lX:Float = ReadFloat( File )
		Local lY:Float = ReadFloat( File )
		Player.SetPosition( lX, lY )
		
		Physics.SetForces( 0, 0 )
		For CP:TC = EachIn Panel.Components
			CP.Active = 0
		Next
		Run = 0
		
		CloseFile( File )
		
	End Method
	
End Type









