
Type TMenueItem Extends TDynamicObject
	
	Global iNextID = 1
	
	Field imgEntry:TImage
	Field imgEntryOver:TImage
	Field Effect:TParticleEmitter
	Field iID
	
	
	Function Init:TMenueItem( iX, iY, img1:TImage, img2:TImage=Null, lEff:TParticleEmitter=Null )
		
		t:TMenueItem = New TMenueItem
		t.iID = iNextID
		t.X = iX
		t.Y = iY
		t.imgEntry = img1
		t.imgEntryOver = img2
		t.W = ImageWidth( img1 )
		t.H = ImageHeight( img1 )
		t.Effect = lEff
		
		iNextID = iNextID + 1
		
		Return t
		
	End Function
	
	
	Method draw( lX, lY )
		
		If over( lX, lY ) Then
			If imgEntryOver
				DrawImage imgEntryOver, X, Y
			Else
				DrawImage imgEntry, X, Y
			EndIf
			If Effect Effect.State = TParticleEmitter.ON
		Else
			DrawImage imgEntry, X, Y
			If Effect Effect.State = TParticleEmitter.OFF
		EndIf
		
		If Effect Then Effect.Update()
		
	End Method
	
End Type