
Type TParticle
	
	Field X:Float
	Field Y:Float
	Field DistX:Float
	Field DistY:Float
	Field Angle
	Field StartTime
	Field Time:Float
	Field EndTime:Float
	Field Speed
	Field Rotation
	Field RotSpeed
	Field Fade:Float
	Field Emitter:TParticleEmitter
	
	
	Function Init:TParticle( lX, lY, lAngle, lTime, lSpeed, lRotSpeed, lEmitter:TParticleEmitter )
		
		Local t:TParticle = New TParticle
		
		t.X = lX
		t.Y = lY
		t.Angle = lAngle
		t.EndTime = lTime
		t.Emitter = lEmitter
		t.Fade = lEmitter.Color.A
		t.Speed = lSpeed
		t.RotSpeed = lRotSpeed
		t.StartTime = MilliSecs()
		
		t.DistX = Cos( lAngle )*lSpeed
		t.DistY = Sin( lAngle )*lSpeed
		
		Return t
		
	End Function
	
	
	Method Update()
		
		Time = MilliSecs()
		
		X :+ DistX
		Y :+ DistY
		Fade = 1-(Time-StartTime)/(EndTime-StartTime)
		Rotation = (Rotation + RotSpeed) Mod 360
		
		Draw()
		If Time > EndTime Then Return 0
		Return 1
		
	End Method
	
	
	Method Draw()
		
		SetColor Emitter.Color.R, Emitter.Color.G, Emitter.Color.B
		SetAlpha Fade
		SetRotation Rotation
		DrawImage Emitter.imgParticle, X, Y
		SetRotation 0
		SetAlpha 1
		SetColor 255,255,255
		
	End Method
	
EndType