
Type TParticleEmitter
	
	Const ON = 1
	Const OFF = 0
	
	Field State
	Field X
	Field Y
	Field W
	Field H
	Field MaxTime
	Field MinTIme
	Field MaxAngle
	Field MinAngle
	Field MinSpeed
	Field MaxSpeed
	Field MinRotSpeed
	Field MaxRotSpeed
	Field Particle:TList
	Field MaxParticle
	Field imgParticle:TImage
	Field Color:TColor
	
	
	Function Init:TParticleEmitter( lX, lY, lW, lH, lMaxAngle, lMinAngle, lMaxTime, lMinTime, lMaxSpeed:Float, lMinSpeed:Float, lMinRot, lMaxRot, lImg:TImage, lColor:TColor, lMaxParticle, lMid )
		
		Local t:TParticleEmitter = New TParticleEmitter
		
		t.X = lX
		t.Y = lY
		t.H = lH
		t.W = lW
		t.MaxAngle = lMaxAngle
		t.MinAngle = lMinAngle
		t.MaxTime = lMaxTime
		t.MinTime = lMinTime
		t.MinSpeed = lMinSpeed
		t.MaxSpeed = lMaxSpeed
		t.MinRotSpeed = lMinRot
		t.MaxRotSpeed = lMaxRot
		t.imgParticle = lImg
		t.Color = lColor
		t.MaxParticle = lMaxParticle
		t.State = ON
		
		If lMid Then MidHandleImage( t.imgParticle )
		
		t.Particle = CreateList()
		
		Return t
		
	End Function
	
	
	Method Update()
		
		Local P:TParticle
		
		If State = ON Then
			If CountList( Particle ) < MaxParticle Then
				P = TParticle.Init( Rand(X, X+W), Rand(Y,Y+H), Rand( MinAngle, MaxAngle ), Rand(MinTime, MaxTime) + MilliSecs(), Rand(MinSpeed, MaxSpeed), Rand(MinRotSpeed, MaxRotSpeed), Self )
				Particle.AddLast( P )
			EndIf
		EndIf
		
		For P:TParticle = EachIn Self.Particle
			If P.Update() = 0 Then Particle.Remove( P )
		Next
		
	EndMethod
	
End Type


