
Type TPlayer Extends TDynamicObject
	
	Field OldX:Float
	Field OldY:Float
	Field AX:Float
	Field AY:Float
	Field R:Int
	Field Rot:Float
	Field ResX:Float
	Field ResY:Float
	
	Field imgBall:TImage[1]
	Field imgShadow:TImage[1]
	
	Function Init:TPlayer( lX, lY, lR, lImgBall:TImage, lImgShadow:TImage )
		
		t:TPlayer = New TPlayer
		
		t.ResX = lX
		t.ResY = lY
		t.X = lX
		t.Y = lY
		t.OldX = lX
		t.OldY = lY
		t.R = lR
		
		t.imgBall[0] = lImgBall
		MidHandleImage( t.imgBall[0] )
		t.imgShadow[0] = lImgShadow
		
		Return t
		
	End Function
	
	
	Method Draw( lOffX, lOffY )
		
		Rot = (Rot + (X-OldX)*2.5) Mod 360
		SetRotation Rot
		DrawImage imgBall[0], X-lOffX, Y-lOffY
		SetRotation 0
		If imgShadow[0] Then DrawImage imgShadow[0], X-R-lOffX, Y-R-lOffY
		
	End Method
	
	
	Method ResetPosition()
		
		X = ResX
		Y = ResY
		OldX = ResX
		OldY = ResY
		AX = 0
		AY = 0
		
	End Method
	
	
	Method SetPosition( lX, lY )
		
		ResX = lX
		ResY = lY
		X = lX
		Y = lY
		OldX = lX
		OldY = lY
		
	End Method
	
End Type



