Const G#=0.1
Const maxL#=500

Type Joint
	Field x#
	Field y#
	
	Field vx#
	Field vy#
	
	Field fix
End Type

Type Bone
	Field j1.Joint
	Field j2.Joint
	
	Field length#
End Type

Type Obj
	Field x#
	Field y#
	
	Field p.Point[50]
	Field count
	
	Field tex.Texture
End Type

Type Point
	Field x#
	Field y#
End Type

Type Texture
	Field rgb[64*64]
End Type

Function cTexture.Texture(path$)
	Local img=LoadImage(path)
	
	If img=0
		Return Null
	EndIf
	
	If ImageWidth(img)<>64 Or ImageHeight(img)<>64
		FreeImage img
		Return Null
	EndIf
	
	Local t.Texture=New Texture
	
	LockBuffer ImageBuffer(img)
	For y=0 To 63
		For x=0 To 63
			t\rgb[y*64+x]=ReadPixelFast(x, y, ImageBuffer(img))
		Next
	Next
	UnlockBuffer ImageBuffer(img)
	
	FreeImage img
	Return t
End Function

Function getRGB(t.Texture, x#, y#)
	; x,y in [0,1)
	
	ix=x*63
	iy=y*63
	
	Return t\rgb[iy*64+ix]
End Function

Graphics3D 800,600,0,2
SetBuffer BackBuffer()

Global started=0
SeedRnd MilliSecs()

loadFile("spidey2d.txt")
movePuppet(200,300)
Global startx=200;, starty=300

Const MAX_TEX=4
Global texture.Texture[MAX_TEX]
texture[0]=cTexture("sonne.png")
texture[1]=cTexture("earth.png")
texture[2]=cTexture("venus.png")
texture[3]=cTexture("moon.png")

arm=0

;0: hip
;1: leg1
;2: leg2
;3: neck
;4: arm1
;5: arm2

Global head.Joint
Global SMHead=LoadImage("Spidey.png") : MidHandle SMHead
Global arms.Joint[1]
Local fixPt.Joint=New Joint
Local rope.Bone

j.joint=First Joint
For i=1 To 5
	j=After j
	If i=4 Then arms[0]=j
	If i=5 Then arms[1]=j
	If i=3 Then head=j
Next

timer=CreateTimer(60)
While Not KeyHit(1)
	Text 10,10,dist
	
	Oval MouseX()-5,MouseY()-5,10,10,0
	
	movePuppet(KeyDown(205)-KeyDown(203),0)
	
	If MouseHit(1)
		started=True
		
		ropeTime=MilliSecs()
		For b.bone=Each Bone
			If b\j1=fixPt Or b\j2=fixPt
				Delete b.bone
			EndIf
		Next
		Delete fixPt
		
		vx#=MouseX()-arms[arm]\x
		vy#=MouseY()-arms[arm]\y
		l#=Sqr(vx^2+vy^2)
		
		vx=vx/l*maxL
		vy=vy/l*maxL
		
		found=0 : t0#=1
		For o.obj=Each Obj
			For i=0 To o\count-1
				dx#=o\p[(i+1) Mod o\count]\x-o\p[i]\x
				dy#=o\p[(i+1) Mod o\count]\y-o\p[i]\y
				
				t#=lineIntersect(arms[arm]\x,arms[arm]\y,vx,vy,o\x+o\p[i]\x,o\y+o\p[i]\y,dx,dy)
				If t>0 And t<t0
					t0=t
					found=1
				EndIf
			Next
		Next
		
		If found
			fixPt=newJoint(arms[arm]\x+vx*t0,arms[arm]\y+vy*t0)
			fixPt\fix=True
		Else
			fixPt=newJoint(arms[arm]\x+vx,arms[arm]\y+vy)
		EndIf
		
		rope=newBone(fixPt,arms[arm])
		
		If fixPt\fix=True
			rope\length=rope\length*0.7
		EndIf
		
		arm=1-arm
	EndIf
	
	If MilliSecs()-ropeTime>1000
		For b.bone=Each Bone
			If b\j1=fixPt Or b\j2=fixPt
				Delete b.bone
			EndIf
		Next
		Delete fixPt
	EndIf
	
	j.joint=First Joint
	
	dist=startx-j\x
	
	If j\x>400 Then
		For o.obj=Each Obj
			o\x=o\x+(400-j\x)
		Next
		startx=startx-(400-j\x)
		movePuppet(400-j\x,0)
	EndIf
	
	If j\x<100 Then
		For o.obj=Each Obj
			o\x=o\x+(100-j\x)
		Next
		startx=startx-(100-j\x)
		movePuppet(100-j\x,0)
	EndIf
	
;	If j\y>300
;		For o.obj=Each Obj
;			o\y=o\y+(300-j\y)
;		Next
;		starty=starty-(300-j\y)
;		movePuppet(0,300-j\y)
;	EndIf
;	
;	If j\y<100 Then
;		For o.obj=Each Obj
;			o\y=o\y+(100-j\y)
;		Next
;		starty=starty-(100-j\y)
;		movePuppet(0,100-j\y)
;	EndIf
	
	test.obj=First obj : test=After test
	If started Or test=Null
		verletBones()
		
		j.joint=First Joint
		o.obj=Last Obj
		If Abs(o\x-j\x)<200
			For i=1 To 10
				o2.obj=New Obj
				o2\x=o\x+Rand(200,600)	;i*500
				o2\y=Rand(100,400)		;Rand(200,400)
				r=Rand(10,30)			;Rand(40,160)
				
				For i2=0 To 35
					addPoint(o2,Cos(i2*10)*r,Sin(i2*10)*r)
				Next
				
				o2\tex=texture[Rand(0,MAX_TEX-1)]
			Next
		EndIf
	EndIf
	
	draw()
	
	If j\y>1000 Or KeyHit(19)
		reset()
	EndIf
	Flip 0 : Cls
	WaitTimer(timer)
Wend : End

Function loadFile(datei$)
	Local stack.Joint[50]
	Local count=0
	
	Local lastO.Obj
	
	dat=ReadFile(datei$)
	While Not Eof(dat)
		lin$=ReadLine(dat)
		cmd$=getCmd(lin$)
		Select cmd$
			Case "<joint>"
				x#=0 : y#=0
				If Instr(lin$,"coords='")
					tmp$=mid2(lin$,Instr(lin$,"coords='")+7,Instr(lin$,"'",Instr(lin$,"coords='")+8))
					x#=Float(Left(tmp$,Instr(tmp$," ")-1))
					y#=Float(mid2(tmp$,Instr(tmp$," "),Instr(tmp$," ",Instr(tmp$," ")+1)))
				EndIf
				
				stack[count]=newJoint(x,y)
				count=count+1
				
				If count>1
					b.bone=newBone(stack[count-1],stack[count-2])
				EndIf
				
				If Right(lin$,2)="/>"
					count=count-1
					stack[count]=Null
				EndIf
			Case "</joint>"
				count=count-1
				stack[count]=Null
			Case "<object>"
				lastO=New Obj
			Case "<pos>"
				lin$=mid2(lin$,Instr(lin$,"pos '")+4,Instr(lin$,"'",Instr(lin$,"pos '")+5))
				x#=Float(Left(lin$,Instr(lin$," ")-1))
				y#=Float(mid2(lin$,Instr(lin$," "),Instr(lin$," ",Instr(lin$," ")+1)))
				lastO\x=x
				lastO\y=y
			Case "<point>"
				x#=0 : y#=0
				If Instr(lin$,"coords='")
					tmp$=mid2(lin$,Instr(lin$,"coords='")+7,Instr(lin$,"'",Instr(lin$,"coords='")+8))
					x#=Float(Left(tmp$,Instr(tmp$," ")-1))
					y#=Float(mid2(tmp$,Instr(tmp$," "),Instr(tmp$," ",Instr(tmp$," ")+1)))
				EndIf
				
				addPoint(lastO,x,y)
		End Select
	Wend
	CloseFile(dat)
End Function

Function getCmd$(lin$)
	Local cmd$
	
	lin$=Trim(lin$)
	cmd$=Left(lin$,Instr(lin$,">"))
	If Instr(cmd$," ")
		cmd$=Left(lin$,Instr(lin$," ")-1)+">"
	EndIf
	
	Return cmd$
End Function

Function mid2$(txt$,start,stopp)
	Return Mid(txt$,start+1,stopp-start-1)
End Function

Function newJoint.Joint(x#,y#)
	j.joint=New Joint
	j\x=x
	j\y=y
	Return j
End Function

Function newBone.Bone(j1.Joint,j2.Joint)
	Local B.Bone=New Bone
	
	B\j1=j1
	B\j2=j2
	
	B\length#=Sqr((j1\x-j2\x)^2+(j1\y-j2\y)^2)
	
	Return B
End Function

Function draw()
	Local B.Bone, J.Joint, O.Obj
	
	LockBuffer BackBuffer()
	
	For B.Bone=Each Bone
		Line B\j1\x,B\j1\y,B\j2\x,B\j2\y
	Next
	
	J.Joint=First Joint
	
	For O.Obj=Each Obj
		If O\count=36
			;For i=0 To O\count-1
			;	Line O\x+O\p[i]\x,O\y+O\p[i]\y,O\x+O\p[(i+1) Mod O\count]\x,O\y+O\p[(i+1) Mod O\count]\y
			;Next
			
			r#=Abs(O\p[0]\x)
			sx#=O\x-r
			sy#=O\y-r
			
			;Oval O\x-r, O\y-r, 2*r,2*r
			
			For y=O\y-r To O\y+r
				For x=O\x-r To O\x+r
					If x>0 And x<GraphicsWidth() And y>0 And y<GraphicsHeight()
						vx#=x-O\x
						vy#=y-O\y
						
						If Sqr(vx*vx+vy*vy)<r
							WritePixelFast x, y, getRGB(O\tex, (x-sx)/(2*r), (y-sy)/(2*r))
						EndIf
					EndIf
				Next
			Next
		EndIf
		
		If O\x-J\x<-500
			Delete O
		EndIf
	Next
	
	UnlockBuffer BackBuffer()
	
	Local dx#, dy#, dl#
	
	dx=head\x-J\x
	dy=head\y-J\y
	
	dl=Sqr(dx*dx + dy*dy)
	
	dx=dx/dl
	dy=dy/dl
	
	DrawImage SMHead, head\x+15*dx, head\y+15*dy
End Function

Function movePuppet(x#,y#)
	For j.joint=Each Joint
		j\x=j\x+x
		j\y=j\y+y
	Next
End Function

Function verletBones()
	For j.joint=Each Joint
		If Not j\fix
			j\vy=j\vy+G#
			
			block=False
			For o.obj=Each Obj
				If inObj(o,j\x+j\vx,j\y+j\vy)
					block=True
				EndIf
			Next
			
			If Not block
				j\x=j\x+j\vx
				j\y=j\y+j\vy
			Else
				j\vx=0
				j\vy=0
			EndIf
		EndIf
	Next
	
	For b.bone=Each Bone
		dx#=(b\j1\x+b\j1\vx)-(b\j2\x+b\j2\vx)
		dy#=(b\j1\y+b\j1\vy)-(b\j2\y+b\j2\vy)
		
		lg#=Sqr(dx^2+dy^2)
		ld#=0.1*(b\length-lg)/lg
		
		dx=dx*ld
		dy=dy*ld
		
		If Not b\j1\fix
			b\j1\vx=b\j1\vx+dx
			b\j1\vy=b\j1\vy+dy
		EndIf
		If Not b\j2\fix
			b\j2\vx=b\j2\vx-dx
			b\j2\vy=b\j2\vy-dy
		EndIf
	Next
End Function

Function inObj(o.Obj,x#,y#)
	Local trash#=0.001
	Local vx1#, vy1#, l1#, vx2#, vy2#, l2#
	
	For i=0 To o\count-1
		vx1#=o\p[(i+1) Mod (o\count)]\x-o\p[i]\x
		vy1#=o\p[(i+1) Mod (o\count)]\y-o\p[i]\y
		l1#=Sqr(vx1^2+vy1^2)
		vx1=vx1/l1 : vy1=vy1/l1
		
		vx2#=x-(o\x+o\p[i]\x)
		vy2#=y-(o\y+o\p[i]\y)
		l2#=Sqr(vx2^2+vy2^2)
		vx2=vx2/l2 : vy2=vy2/l2
		
		If Abs(vx1-vx2)<trash And Abs(vy1-vy2)<trash And l2<l1
			Return True
		EndIf
	Next
	
	Local in=False
	
	For i=0 To o\count-1
		If i Then j=i-1 Else j=o\count-1
		x1#=o\x+o\p[i]\x
		y1#=o\y+o\p[i]\y
		x2#=o\x+o\p[j]\x
		y2#=o\y+o\p[j]\y
		If ((((y1 <= y) And (y < y2)) Or ((y2 <= y) And (y < y1))) And (x < (((x2 - x1) * (y - y1)) / (y2 - y1)) + x1))
			in = Not in
		EndIf
	Next
	
	Return in
End Function

Function addPoint(o.Obj,x#,y#)
	o\p[o\count]=New Point
	
	o\p[o\count]\x=x
	o\p[o\count]\y=y
	
	o\count=o\count+1
End Function

Function reset()
	Local J.Joint
	
	Delete Each Obj
	Delete Each Point
	Delete Each Joint
	Delete Each Bone
	
	loadFile("spidey2d.txt")
	movePuppet(200,300)
	startx=200
	
	J.Joint=First Joint
	For i=1 To 5
		J=After J
		If i=4 Then arms[0]=J
		If i=5 Then arms[1]=J
		If i=3 Then head=J
	Next
	
	started=0
End Function

Function lineIntersect#(x1#,y1#,vx1#,vy1#,x2#,y2#,vx2#,vy2#)
	Local trash#=0.001
	
	If Abs(vx1-vx2)<trash And Abs(vy1-vy2)<trash
		Return -1
	EndIf
	
	k#=(x1*vy1-y1*vx1+vx1*y2-vy1*x2)/(vx2*vy1-vy2*vx1)
	t#=(x1*vy2-y1*vx2+vx2*y2-vy2*x2)/(vx2*vy1-vy2*vx1)
	
	If k>0 And k<1 And t>0 And t<1
		Return t
	EndIf
	Return -1
End Function
;~IDEal Editor Parameters:
;~C#Blitz3D